#!/usr/bin/perl

# Analyse des CGI Datenstroms

# Welche Methode wurde verwendet?
# Datensatz entsprechend der Methode in
# die Variable $Daten speichern:
if($ENV{'REQUEST_METHOD'} eq 'GET')
{
  $Daten = $ENV{'QUERY_STRING'}
}
else
{
  read(STDIN, $Daten, $ENV{'CONTENT_LENGTH'});
}

# Formularfelder aufteilen
# In den geraden Variablen Formular[0], Formular [2] etc.
# werden die Formularfeldnamen gespeichert
# In den ungeraden Variablen Formular[1], Formular [3] etc.
# werden die eingegebenen Formulardaten gespeichert:
@Formularfelder = split(/&/, $Daten);
foreach $Feld (@Formularfelder)
{
  ($name, $value) = split(/=/, $Feld);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ s/<!--(.|\n)*-->//g;
  $Formular[$i] = $name;
  $i = $i + 1;
  $Formular[$i] = $value;
  $i = $i + 1;
}

# Mini Testroutine,die alle Formulardaten ausgibt:
print "Content-type: text/html\n\n";
print <<kopfende;
<HTML>

<HEAD>
  <TITLE> CGI Testseite </TITLE>
</HEAD>

<BODY>
Diese Daten wurden gerade im Formular eingegeben: <P>

<TABLE BORDER=1>
kopfende

for ($i=0; $i<=$#Formular; $i=$i+2)
{
  print "<TR>\n";
  print "  <TD> <B>", $Formular[$i], "</B> </TD>\n";
  print "  <TD> ", $Formular[$i+1], "&nbsp; </TD>\n";
  print "</TR>\n";
}

print <<htmlende;
</TABLE>

</BODY>

</HTML>
htmlende
exit;